package edu.sdsu.cs.util;

/*
 * Represents the characters allowed in a Trie
 */
public class Alphabet {
	private String letters;
	
	public static Alphabet ascii() {
		return new Alphabet("abcdefghijklmnopqrstuvwxyz");
	}
	
	public Alphabet(String lettersInAlphabet) {
		letters = lettersInAlphabet;
	}
	
	/*
	 * Returns true if all characters in argument are in the alphabet
	 */
	public boolean validCharacters(String characters) {
		String lowercase = characters.toLowerCase();
		for (int k = 0; k < lowercase.length(); k++) {
			String singleChar = String.valueOf(lowercase.charAt(k));
			if (!letters.contains(singleChar)) return false;
		}
		return true;
	}
	
	/*
	 * Returns character that is in dictionary order after the argument 
	 */
	public char after(char character) {
		if (character == last())
			throw new java.util.NoSuchElementException();
		int charIndex = letters.indexOf(character);
		if (charIndex == -1)
			throw new java.util.NoSuchElementException();
		return this.charAt(charIndex+1);
	}

	/*
	 * Returns the index'th character in the alphabet
	 * Indexing starts at zero
	 */
	public char charAt(int index) {
		return letters.charAt(index);
	}
	
	/*
	 * Returns first character in the alphabet
	 */
	public char first() {
		return this.charAt(0);
	}
	
	public char last() {
		return this.charAt(size()-1);
	}
	
	public int size() {
		return letters.length();
	}
	
	public int indexOf(char character) {
		return letters.indexOf(character);
	}
}
