package edu.sdsu.cs.util;
/*
 * Defines interface for TrieNodes
 */
public abstract class TrieNode {
	
	protected TrieInnerNode parent;
	protected Alphabet characterSet;
	
	public TrieNode(Alphabet letters, TrieInnerNode parent) {
		this.characterSet = letters;
		this.parent = parent;
	}

	public abstract void accept(TrieVisitor visitor);
	
	public abstract boolean  add(WordParameter wordToAdd);
	
	public Alphabet characterSet() {
		return this.characterSet;
	}
	
	public abstract boolean contains(WordParameter word);

	public abstract String getWord();
	
	public boolean isNull() {
		return false;
	}
	
	public boolean isWord() {
		return false;
	}
	
	public abstract int size();
	
	protected void setParent(TrieInnerNode newParent) {
		parent = newParent;
	}
}
