package edu.sdsu.cs.util;

public class TrieNullNode extends TrieNode {
	public TrieNullNode(Alphabet letters, TrieInnerNode parent) {
		super(letters,parent);
	}
	
	public void accept(TrieVisitor visitor) {
		visitor.visitTrieNullNode(this);
	}
	
	public  boolean  add(WordParameter wordToAdd) {
		TrieInnerNode newMe = this.becomeInnerNode(wordToAdd.currentChar());
		return newMe.add(wordToAdd);
	}
	
	@Override
	public boolean contains(WordParameter word) {
		return false;
	}
	
	@Override
	public String getWord() {
		return parent.getWord();
	}

	public boolean isNull() {
		return true;
	}

	@Override
	public int size() {
		return 0;
	}

	/*
	 * Replace NullNode in Trie with an InnerNode 
	 */
	private TrieInnerNode becomeInnerNode(char letter) {
		//change all references to self to point to myReplacement
		TrieInnerNode myReplacement = new TrieInnerNode(characterSet,parent,letter );
		parent.replaceNodeWith(myReplacement);
		return myReplacement;
	}

}
