package edu.sdsu.cs.util;

/*
 * Represents a node that contains the last letter of a word in a trie
 */
public class TrieWordNode extends TrieInnerNode {

	public TrieWordNode(Alphabet letters, TrieInnerNode parent, char character,
			TrieNode[] subtries) {
		super(letters, parent, character);
		this.subtries = subtries;
		for (TrieNode child : this.subtries) {
			child.setParent(this);
		}
	}

	public void accept(TrieVisitor visitor) {
		visitor.visitTrieWordNode(this);
	}

	@Override
	public boolean contains(WordParameter word) {
		if (word.atEnd())
			return true;
		return super.contains(word);
	}

	public boolean isWord() {
		return true;
	}

	@Override
	public int size() {
		return 1 + super.size();
	}
}
