package edu.sdsu.cs.util;

import java.util.ArrayList;

public class VisitorWithStrategy extends TrieVisitor {
	private ArrayList<String> words = new ArrayList();
	private Accepter pickWords;
	
	public VisitorWithStrategy(Accepter strategy) {
		pickWords = strategy;
	}
	
	public ArrayList<String> words() {
		return words;
	}
	
	public void clear() {
		words = new ArrayList<String>();
	}
	
	@Override
	public void visitTrie(Trie visitee) {
	}

	@Override
	public void visitTrieInnerNode(TrieInnerNode visitee) {
	}

	@Override
	public void visitTrieNullNode(TrieNullNode visitee) {
	}

	@Override
	public void visitTrieWordNode(TrieWordNode visitee) {
		String nextWord = visitee.getWord();
		if (pickWords.shouldKeep(nextWord))
		words.add(nextWord);
	}

}