package edu.sdsu.cs.util;

/*
 * Keeps track of location in a word as traverse down a Trie
 */
public class WordParameter {
	private String word;
	private int currentIndex;
	
	public WordParameter(String word) {
		this.word = word;
		this.currentIndex = -1;
	}
	
	public boolean atEnd() {
		return word.length() - 1 <= currentIndex;
	}
	
	public char nextChar() {
		return this.word.charAt(currentIndex + 1);	
	}
	
	public char currentChar() {
		return this.word.charAt(currentIndex);	
	}
	
	/*
	 * Call when go down the next level of the trie
	 */
	public WordParameter nextLevel() {
		currentIndex++;
		return this;
	}
	
	public char previousChar() {
		return this.word.charAt(currentIndex -1);
	}
}
