package edu.sdsu.cs.util.tests;

import static org.junit.Assert.*;

import org.junit.Test;

import edu.sdsu.cs.util.Alphabet;

public class AlphabetTests {

	@Test
	public void testValidLetters() {
		Alphabet ads = new Alphabet("ads");
		assertTrue(ads.validCharacters("adds"));
		assertFalse(ads.validCharacters("dat"));
	}
	
	@Test(expected = java.util.NoSuchElementException.class)
	public void testAlphabet() {
		Alphabet ascii = Alphabet.ascii();
		assertEquals('a', ascii.first());
		assertEquals('z', ascii.last());
		assertEquals(26, ascii.size());
		assertEquals('b', ascii.after('a'));
		int bIndex = ascii.indexOf('b');
		assertEquals(1, bIndex);
		//expect exception
		ascii.after('z');
	}
	
	@Test(expected = java.util.NoSuchElementException.class)
	public void testIndexFor() {
		Alphabet ads = new Alphabet("ads");
		assertEquals(0, ads.indexOf('a'));
		assertEquals(1, ads.indexOf('d'));
		assertEquals(2, ads.indexOf('s'));
		assertEquals('d', ads.after('a'));
	
		//expect exception
		ads.after('s');
	}
}
